%define anolis_release 1
%define   baseversion     1.2.9
%global   _hardened_build 1

Summary: Advanced Linux Sound Architecture (ALSA) utilities
Name:    alsa-utils
Version: %{baseversion}
Release: %{anolis_release}%{?dist}
License: GPLv2+
URL:     http://www.alsa-project.org/
Source:  ftp://ftp.alsa-project.org/pub/utils/alsa-utils-%{version}.tar.bz2
Source4: alsaunmute
Source5: alsaunmute.1
Source10: alsa.rules
Source11: alsactl.conf
Source20: alsa-restore.service
Source22: alsa-state.service

BuildRequires:  gcc
BuildRequires: alsa-lib-devel >= %{baseversion}
BuildRequires: libsamplerate-devel
BuildRequires: ncurses-devel
BuildRequires: gettext-devel
BuildRequires: xmlto
BuildRequires: python3-docutils
BuildRequires: systemd
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd
# use latest alsa-lib - the executables in this package requires latest API
Requires: alsa-lib >= %{baseversion}
Requires: alsa-ucm >= %{baseversion}

%description
This package contains command line utilities for the Advanced Linux Sound
Architecture (ALSA).

%package -n alsa-ucm-utils
Summary: Advanced Linux Sound Architecture (ALSA) - Use Case Manager

%description -n alsa-ucm-utils
This package contains Use Case Manager tools for Advanced Linux Sound
Architecture (ALSA) framework.

%package -n alsa-topology-utils
Summary: Advanced Linux Sound Architecture (ALSA) - Topology
Requires: alsa-topology >= %{baseversion}

%description -n alsa-topology-utils
This package contains topology tools for Advanced Linux Sound
Architecture (ALSA) framework.

%package alsabat
Summary: Advanced Linux Sound Architecture (ALSA) - Basic Audio Tester
BuildRequires: fftw-devel
BuildRequires: make

%description alsabat
This package contains tool for basic audio testing using Advanced Linux Sound
Architecture (ALSA) framework and Fast Fourier Transform library.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -n %{name}-%{version} -p1

%build
%configure CFLAGS="$RPM_OPT_FLAGS -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64" --disable-alsaconf \
   --with-udev-rules-dir=%{_prefix}/lib/udev/rules.d \
   --with-systemdsystemunitdir=%{_unitdir}
%make_build
cp %{SOURCE4} .

%install
%global alsacfgdir %{_prefix}/lib/alsa

%make_install
%find_lang %{name}

# Install ALSA udev rules
mkdir -p %{buildroot}/%{_prefix}/lib/udev/rules.d
install -p -m 644 %{SOURCE10} %{buildroot}/%{_prefix}/lib/udev/rules.d/90-alsa-restore.rules
mkdir -p %{buildroot}/%{_unitdir}
install -p -m 644 %{SOURCE20} %{buildroot}/%{_unitdir}/alsa-restore.service
install -p -m 644 %{SOURCE22} %{buildroot}/%{_unitdir}/alsa-state.service

# Install support utilities
mkdir -p -m755 %{buildroot}/%{_bindir}
install -p -m 755 %{SOURCE4} %{buildroot}/%{_bindir}
mkdir -p -m755 %{buildroot}/%{_mandir}/man1
install -p -m 644 %{SOURCE5} %{buildroot}/%{_mandir}/man1/alsaunmute.1

# Move /usr/share/alsa/init to /usr/lib/alsa/init
mkdir -p -m 755 %{buildroot}%{alsacfgdir}
mv %{buildroot}%{_datadir}/alsa/init %{buildroot}%{alsacfgdir}

# Link /usr/lib/alsa/init to /usr/share/alsa/init back
ln -s ../../lib/alsa/init %{buildroot}%{_datadir}/alsa/init

# Create a place for global configuration
mkdir -p -m 755 %{buildroot}/etc/alsa
install -p -m 644 %{SOURCE11} %{buildroot}/etc/alsa

# Create /var/lib/alsa tree
mkdir -p -m 755 %{buildroot}%{_sharedstatedir}/alsa

%generate_compatibility_deps

%files -f %{name}.lang
%license COPYING
%config /etc/alsa/*
%{_prefix}/lib/udev/rules.d/*
%{_unitdir}/*
%{_unitdir}/sound.target.wants/*
%{alsacfgdir}/init/*
%{_bindir}/aconnect
%{_bindir}/alsaloop
%{_bindir}/alsamixer
%{_bindir}/alsaunmute
%{_bindir}/amidi
%{_bindir}/amixer
%{_bindir}/aplay
%{_bindir}/aplaymidi
%{_bindir}/arecord
%{_bindir}/arecordmidi
%{_bindir}/aseqdump
%{_bindir}/aseqnet
%{_bindir}/axfer
%{_bindir}/iecset
%{_bindir}/speaker-test
%{_sbindir}/*
%exclude %{_sbindir}/alsabat-test.sh
%{_datadir}/alsa/
%{_datadir}/sounds/*
%{_mandir}/man7/*
%{_mandir}/man1/alsactl.1.zst
%{_mandir}/man1/alsaloop.1.zst
%{_mandir}/man1/alsamixer.1.zst
%{_mandir}/man1/alsaunmute.1.zst
%{_mandir}/man1/amidi.1.zst
%{_mandir}/man1/amixer.1.zst
%{_mandir}/man1/aplay.1.zst
%{_mandir}/man1/aplaymidi.1.zst
%{_mandir}/man1/arecord.1.zst
%{_mandir}/man1/arecordmidi.1.zst
%{_mandir}/man1/aseqdump.1.zst
%{_mandir}/man1/aseqnet.1.zst
%{_mandir}/man1/axfer.1.zst
%{_mandir}/man1/axfer-list.1.zst
%{_mandir}/man1/axfer-transfer.1.zst
%{_mandir}/man1/iecset.1.zst
%{_mandir}/man1/speaker-test.1.zst
%{_mandir}/man1/aconnect.1.zst
%{_mandir}/man1/alsa-info.sh.1.zst

%dir /etc/alsa/
%dir %{alsacfgdir}/
%dir %{alsacfgdir}/init/
%dir %{_sharedstatedir}/alsa/
%dir %{abidir}
%{abidir}/alsactl-option.list
%{abidir}/alsaloop-option.list
%{abidir}/alsamixer-option.list
%{abidir}/amidi-option.list
%{abidir}/amixer-option.list
%{abidir}/aplay-option.list
%{abidir}/axfer-option.list
%{abidir}/libalsatplg_module_nhlt.dump
%{abidir}/speaker-test-option.list

%files -n alsa-ucm-utils
%{_bindir}/alsaucm
%{_mandir}/man1/alsaucm.1.zst
%{abidir}/alsaucm-option.list

%files -n alsa-topology-utils
%{_bindir}/alsatplg
%{_mandir}/man1/alsatplg.1.zst
%{_libdir}/alsa-topology/libalsatplg_module_*
%{abidir}/alsatplg-option.list

%files alsabat
%{_bindir}/alsabat
%{_sbindir}/alsabat-test.sh
%{_mandir}/man1/alsabat.1.zst
%{abidir}/alsabat-option.list
%{abidir}/alsabat-test.sh-option.list

%files doc
%doc ChangeLog README.md TODO alsamixer/alsamixer.rc.example

%pre
if [ ! -r %{_unitdir}/alsa-state.service ]; then
  [ -d /etc/alsa ] || mkdir -m 0755 /etc/alsa
  echo "# Remove this file to disable the alsactl daemon mode" > \
                                                    /etc/alsa/state-daemon.conf
fi

%post
if [ -s /etc/alsa/asound.state -a ! -s /etc/asound.state ] ; then
  mv /etc/alsa/asound.state /etc/asound.state
fi
if [ -s /etc/asound.state -a ! -s %{_sharedstatedir}/alsa/asound.state ] ; then
  mv /etc/asound.state %{_sharedstatedir}/alsa/asound.state
fi
%systemd_post alsa-state.service

%preun
%systemd_preun alsa-state.service

%postun
%systemd_postun_with_restart alsa-state.service

%changelog
* Thu May 04 2023 Funda Wang <fundawang@yeah.net> - 1.2.9-1
- New version 1.2.9

* Tue Mar 28 2023 happy_orange <songnannan@linux.alibaba.com> - 1.2.8-1
- init package
